source("generate.R")
source("basic.R")
source("test_statistic.R")
source("DGP_1.R")
source("DGP_2.R")

kernel=function(x)
{
  val<--3*(1-x^2)/4*(sign(abs(x)-1)-1)/2
  val
}

LY_test=function(ydata,data_factor,Sigma,sn,sp,sd,h)
{
ones<-matrix(1,sn,1)
X<-cbind(ones,data_factor)
para_e<-0
wet<-0
for (ii in 1:sn)
{
weight<-kernel((c(1:sn)-ii)/(h*sn))/(h*sn)
t_weight<-ginv(t(X)%*%diag(weight)%*%X)%*%t(X)%*%diag(weight)
alpha_weight<-t_weight[1,]
para_e<-para_e+alpha_weight%*%ydata/sn
wet<-wet+alpha_weight/sn
}

alpha_ave<-para_e
std_full<-t(wet)%*%wet
LY_test<-alpha_ave%*%ginv(Sigma)%*%t(alpha_ave)/(std_full)
}