source("generate.R")
source("DGP_1.R")
source("DGP_2.R")
source("basic.R")
source("test_statistic.R")
source("adj_test.R")
source("LY_test.R")

main_DGP_1=function(sn,sp,c)
{
nsimu<-1000
sd<-1
L<-5
h<-2*sn^(-1/3)

result<-matrix(,nsimu,2)
for (ii in 1:nsimu)
{
data<-DGP_1(sn,sp,sd,c)
ydata<-data[[1]]
data_fac<-data[[2]]
Sigma<-data[[3]]
t_stat1<-test_statistic(ydata,data_fac,Sigma,sn,sp,sd,L)
t_stat2<-LY_test(ydata,data_fac,Sigma,sn,sp,sd,h)
result[ii,]<-c(t_stat1[[1]],t_stat2[[1]])
}

result<-as.matrix(result)
pv_1<-length(which(abs(result[,1])>1.96))/nsimu
pv_2<-length(which(abs(result[,2])>1.96))/nsimu

return(list(pv_1,pv_2))
}