source("generate.R")
source("basic.R")

test_statistic=function(ydata,data_factor,Sigma,sn,sp,sd,L){

#basis<-matrix(,sn,L*(sd+1))
#for (ii in 1:sn)
#{
#basis_alpha<-basic(ii/sn)
#-colMeans(basic(c(1:sn)/sn))
#basis_beta<-basic(ii/sn)
#basis_beta<-matrix(t(basic(ii/sn))%*%data_factor[ii,],1,sd*L)
#basis[ii,]<-cbind(as.matrix(basis_alpha),basis_beta)
#}

q<-3
J<-L-q-1
basic_alpha<-bs(c(1:sn)/sn,df=(q+1+J),degree=q,intercept=TRUE)
basic_alpha_adj<-basic_alpha-seq(1,1,length=sn)%*%t(colMeans(basic_alpha))   

basic_beta<-bs(c(1:sn)/sn,df=(q+1+J),degree=q,intercept=TRUE)
basic_beta_adj<-matrix(,sn,L*sd)
for (ii in 1:sn)
{
basic_betai<-as.matrix(basic_beta[ii,])
data_factori<-as.matrix(data_factor[ii,])
basic_beta_adj[ii,]<-matrix(basic_betai%*%t(data_factori),1,sd*L)
}

basis<-cbind(basic_alpha_adj,basic_beta_adj)
basis_full<-cbind(basic_alpha,basic_beta_adj)

hat_beta_adj<-ginv(t(basis_full)%*%basis_full)%*%t(basis_full)%*%ydata
hat_error_adj<-ydata-basis_full%*%hat_beta_adj

hat_beta<-ginv(t(basis)%*%basis)%*%t(basis)%*%ydata
hat_error<-ydata-basis%*%hat_beta

Pz<-basis%*%ginv(t(basis)%*%basis)%*%t(basis)

Mz<-diag(sn)-Pz

adj_val<-Mz%*%rep(1,sn)
adj_sum<-(sum(adj_val^2))^2-sum(adj_val^4)

test_sta<-sum((colMeans(hat_error))^2)*sn/sp-sum(hat_error^2)/(sn*sp)

hat_Sigma<-cov(hat_error)
len<-(sd+1)*L
hat_Sigma2<-sn^2*(sn+1-len)^(-1)*(sn-len)^(-1)
hat_Sigma2<-hat_Sigma2*(sum(hat_Sigma^2)-sum(diag(hat_Sigma))^2/(sn-len))

test_sd<-2*adj_sum*hat_Sigma2/(sp^2*sn^2)
test_stat<-test_sta/sqrt(test_sd)


return(list(test_stat,hat_error,Pz,hat_error_adj))
}
