source("generate.R")
source("basic.R")
source("test_statistic.R")
source("DGP_1.R")
source("DGP_2.R")

bootstrap<-function(ydata,data_factor,Sigma,sn,sp,sd,L)
{
estres<-test_statistic(ydata,data_factor,Sigma,sn,sp,sd,L) #estimation of the reduced model
Pz<-estres[[3]]
hat_error<-estres[[2]]
TtildaNT<-estres[[1]]    #test statistic from the sample
xhat<-ydata-hat_error

hat_full<-estres[[4]]

boot<-200
TtildaNTboot=seq(0,0,length=boot)
for(b in 1:boot)
{
U=runif((sn*sp))
pp=(sqrt(5)+1)/(2*sqrt(5))
vs=(U<=pp)*(1-sqrt(5))/2+(U>pp)*(sqrt(5)+1)/2
vs=matrix(vs,nrow=sn,ncol=sp)
estar=hat_full*vs
xstar=xhat+estar
result=test_statistic(xstar,data_factor,Sigma,sn,sp,sd,L)
TtildaNTboot[b]=result[[1]] 
}

tNstar=sort(abs(TtildaNTboot))
power<-length(which(tNstar>abs(TtildaNT)))/boot
#tNstar=tNstar[floor(boot*(1-siglevel/2))+1]
#power=as.numeric(abs(TtildaNT)>=tNstar)

return(list(power))
 
}
