library(MASS)

generate=function(sn,sp,sd){
  
ydata<-matrix(,sn,sp)

Sigma<-matrix(,sp,sp)  
for(ii in 1:sp){
    Sigma[ii,]<-0.5^abs(ii-c(1:sp))
}

rd_factor<-runif(sd,0.5,1.5)
data_fac<-mvrnorm(sn,rep(0,sd),diag(rep(1,sd)))

for (ii in 1:sn)
{
error<-mvrnorm(1,rep(0,sp),Sigma)
beta<-matrix(rep(rd_factor*(1+(ii/sn-0.5)*0.5),sp),sd,sp)
ydata[ii,]<-error+data_fac[ii,]%*%beta
}

return(list(ydata,data_fac,Sigma))

}
